RISolve

# History
- [I've created my first parser using RIS API, daily updated. Failed because I tried to do too much automatically (e.g. recognizing headers](https://gitlab.com/PhilippHofer/law)
- [Using print-website, I've extracted stuff w/ regex.](https://gitlab.com/PhilippHofer/ris/)
- [Tried to create a parser using print-website, proper(-ish) parser](https://gitlab.com/PhilippHofer/ris2)

# Goals

- [x] I want to have the text of the law.
- [x] I want to see the structure (proper headers) of the law.
- [ ] I want to be able to make comments (e.g. Erschöpfung) on certain parts
- [ ] I want to see since when this paragraph is in use.
- [~] Lawtext should be updateable

# Technical

- I don't want to restrict myself with a [parser combinators](docs.rs/nom) but code it myself using *recursive descent* parser.
- Be strict in what I process. Fail if anything unexpected happens. The user should handle this case. It's fine if one decides to ignore the new/unexpected field, but it should be done deliberately.

# Progress / Functions

- [x] Parse structure of law into struct using Deserilize trait, pot. multiple requests (if > 100 paragraphs)
- [x] Parse risdok using own *RD parser*, again strict: fail if anything not expected happens,  not sure (yet) if I want to operate on strings, or first parse using off-the-shelve XML reader (prob. 2nd option)
  
# Next step

- [ ] Parse ABGB
- [ ] Create config files for laws
	- law_id
	- replace stuff
	- headers
- [ ] Create argument parse
	- `--law mschg.conf`

# Naming

- Law ("Gesetz"): e.g. UHG, TEG, ABGB
- Section ("Paragraph")
- Subsection ("Absatz")
- Item ("Ziffer")
- Heading-{1,2,3,...} 
  
  
# "Scripts"
- Retrieve overview law: `curl -X POST "https://data.bka.gv.at/ris/api/v2.6/Bundesrecht" -H "Content-Type: application/x-www-form-urlencoded" -d "Applikation=BrKons" -d "Gesetzesnummer=10001899" -d "DokumenteProSeite=OneHundred" -d "Seitennummer=1" -d "Fassung.FassungVom=2023-11-03" | jq . > law.json`
